#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <math.h>

int main(int argc, char *argv[]) {
	int i;
	sigset_t intmask; 
	int repeatfactor;
/*	double y = 0.0; */
	int y; 

	if (argc != 2) {
		fprintf(stderr, "Usage: %s repeatfactor\n", argv[0]);
		return 1;
	}

	repeatfactor = atoi(argv[1]);
	if ((sigemptyset(&intmask)==-1) || (sigaddset(&intmask, SIGINT)==-1)){
		perror("Failed to initialize the signal mask");
		return 1;
	}

	for ( ; ; ) {
		if (sigprocmask(SIG_BLOCK, &intmask, NULL) == -1)
			break;
		fprintf(stderr, "SIGINT signal blocked\n");
		
		for (i = 0; i < repeatfactor; i++)
	/*		y += sin((double)i); */
			y = y+10*i;
			fprintf(stderr, "Blocked calculation is finished, y = %d\n", y);
		
		if (sigprocmask(SIG_UNBLOCK, &intmask, NULL) == -1)
			break;
		fprintf(stderr, "SIGINT signal unblocked\n");
		
		for (i = 0; i < repeatfactor; i++)
	/*		y += sin((double)i); */
			y = y+10*i;
			fprintf(stderr, "Unblocked calculation is finished, y=%d\n", y);
		for ( ; ; ) {};
	}
	perror("Failed to change signal mask");
	return 1;
}

